/*
 * Blinds.h
 *
 *  Created on: Nov 24, 2014
 *      Author: David Drake
 */

#ifndef BLINDS_H_
#define BLINDS_H_

#include "Schedule_Admin.h"
#include "Motor_Driver.h"
#include "SD_Driver.h"
#include "XBEE_Driver.h"
#include "Object_Admin.h"
#include "Client_Admin.h"
#include "LED_Driver.h"

//serial number is stored as a macro for easy modification
#define SER_NUM 1

//possible states for the Client Admin object
#define CLT_OFFLINE 0
#define CLT_IDLE 1
#define CLT_BOOTUP 2
#define CLT_SEND_SCHD 3
#define CLT_RCV_SCHD 4
#define CLT_ERROR 99

#define GOOD_LED 19
#define BAD_LED 18
#define MOT_ENB 10
#define MOT_DIR 12
#define HV_ENB 11
#define SW1 5
#define SW2 6
#define ENCA 9
#define XB_SLEEP 3
#define XB_SPI_SEL 4
#define SCLK 7
#define MOSI 15
#define MISO 14
#define SD_CS 8

#define TICKS 29400//the pwm module operates at 490Hz. When time hits 490 clicks, a second has passed
//29400 is a minute


#endif /* BLINDS_H_ */
