/*
 * Client_Admin.h
 *
 *  Created on: Jan 13, 2015
 *      Author: Room 12
 */

#ifndef CLIENT_ADMIN_H_
#define CLIENT_ADMIN_H_

#include <Energia.h>

//this key indicates where data will be saved within the response array
#define SER_INDEX_1 0
#define SER_INDEX_2 1
#define REQ_INDEX 2
#define BLIND_HEIGHT_INDEX 3
#define CT_INDEX_1 4
#define CT_INDEX_2 5
#define SCHEDULE_INDEX 6
#define SRV_REQ_INDEX 2


class Client_Admin{
public:
	//initializer and init
	Client_Admin();
	void init();

	//other public methods
	void set_online();
	void set_offline();
	int get_clt_state();
	void recv_srv_pckt(unsigned char *resp, int length);
	void send_srv_msg(byte srv_msg_type);
	void bootup();
	void check_server();
	void check_flags();

private:
	//methods
	byte _prep_srv_msg(unsigned char* buffer, byte srv_msg_type);
	void _srv_pckt_failure();

	//variables
	byte _clt_state;//this value represents the state of the circuit with respect to the server. Is the circuit
	//connected, has it booted up yet? etc etc.
	byte _clt_counter;//count the number of times a message is sent to the server
};

#endif /* CLIENT_ADMIN_H_ */
