/* MotorDriver.h
 *
 *  Created on: Nov 10, 2014
 *      Author: David Drake

 this file will eventually be used to give inputs to control the motor
 For now this is only being used to flash a light for debugging purposes
 */


#ifndef MOTOR_DRIVER_H_
#define MOTOR_DRIVER_H_

#include "Energia.h"

//forward declarations
class Schedule_Admin;
class SD_Driver;

#define DEFAULT_HEIGHT 90
#define DEFAULT_RADIUS 2
#define SWITCH_IDLE 0
#define SWITCH_PUSH_1 1
#define SWITCH_COOLDOWN 2
#define SWITCH_PUSH_AGAIN 3
#define SWITCH_LOCKED 4
#define SWITCH_LOCKED_EVENT 5

#define COOLDOWN_PERIOD 200
#define ENC_COOLDOWN_MAX 30000


class Motor_Driver
{

public:



	Motor_Driver();
	void init();
	void update_enc();
	void set_radius(int radius);
	void set_height(int height);
	void set_right_hand(short int tf);
	void motor_up(int priority);
	void motor_down(int priority);
	void handle_switch();
	void handle_enc();
	void motor_stop();
	void check_flags();
	int get_prct_height();



private:

	//private working variables
	long int _max_enc_clicks;
	long int _enc_clicks;
	int _cooldown_ref;
	short int _state;
	short int _right_handed; //when moving blinds up, must top cylinder spin according to RHR (thumb out?)
	int _height;
	int _radius;
	int _enc_cooldown;
};

#endif /* MOTOR_DRIVER_H_ */
