#include <Energia.h>
#include <MspFlash.h>
#include <pfatfs.h>
#include <pffconf.h>
#include <SPI.h>
#include "Blinds.h"

void setup();
void loop();


//NEW CODE
Motor_Driver motor;
XBEE_Driver xbee=XBEE_Driver();
Schedule_Admin schd=Schedule_Admin();
SD_Driver sd;
Client_Admin client=Client_Admin();
LED_Driver led;

//ORIGINAL CODE
//Motor_Driver motor(19,18,13,12,6,5,9,10);


// the setup routine runs once when you press reset:
void setup() {
	int i;
	WDTCTL = WDTPW + WDTHOLD; //kill watchdog


	led.init();

	sd.init();
	motor.init();
	schd.init();
	xbee.init();
	client.init();
	//schd.restart_rtc_clock(0);

}

// the loop routine runs over and over again forever:
void loop() {

	led.check_flags();

	sd.check_flags();
	schd.check_flags();
	motor.check_flags();
	xbee.check_flags();
	client.check_flags();


}



