function send_srv_msg (query, exit_function)
{
	//all functions that communicate with server-side php will use this module
	//the module will prepare a message that contains the type of query is being sent
	//and will include any necessary variables
	
	//this module will check if it is jstor, if so, it will process and output 
	//an array corresponding to the passed info.
	
	//if only a message is sent, the value will be the messaage
	
	//if an error is received, the program will log-off immidiately with an error message to user

	//initialize an object to communicate with the server	
	
	//this module behaves oddly, it gets a function call onreadystatechange when it receives a response
	//exit_function is the value passed to this function that deals with the results
	var xmlhttp;
	
	
	
	if(window.XMLHttpRequest)
	{
		//this is for modern browsers
		xmlhttp=new XMLHttpRequest();
	}
	else
	{
		//for IE6 and IE5
		xmlhttp= new ActiveXObject("Microsoft.XMLHTTP");
	}


	//this defines operation upon response
	xmlhttp.onreadystatechange=function()
	{
		if (xmlhttp.readyState==4 && xmlhttp.status==200)
		{
			

			//parse JSON
			try
			{
				response_obj = JSON.parse(xmlhttp.responseText);
				exit_function(response_obj);
				
			}
			//if the format is not json, try to parse the normal text
			catch (e)
			{
				if(xmlhttp.responseText.slice(0,5)=="ERROR")
				{
				
					//php has returned an error, exit the screen immediately
					window.top.location.replace("error.html");
				}
				else
				{

					exit_function( xmlhttp.responseText);
				}	
			}
		}
	}

	//send the response
	xmlhttp.open("POST","server_handler.php",true);
	xmlhttp.setRequestHeader("Content-type","application/x-www-form-urlencoded");
	xmlhttp.send(query);
	xmlhttp.send();
	

}

function finish_logout()
{
	//erase the cookie
	document.cookie="session=;expires=Thu,01 Jan 1970 00:00:01 GMT;";
	//redirect user if succesful
	window.location.replace("index.html");
}

function logout ()
{
	//this function is launched when a logged in user clicks the logout button
	//on the nav bar, send a message and leave
	
	//prepare a response
	query="req=logout";
	send_srv_msg(query, finish_logout);
	
	//this defines operation upon response
	xmlhttp.onreadystatechange=function()
	{
		if (xmlhttp.readyState==4 && xmlhttp.status==200)
		{
			//show the response
			//obj = JSON.parse(xmlhttp.responseText);
			if(xmlhttp.responseText=="OK"){
				window.location.replace("index.html");
			}
		}
	}
}

function change_password()
{
	//this function is launched when a logged in user clicks the change password button
	//on the nav bar
	window.location.replace("change_password.html");
}

function home()
{
	//this function is launched when a logged in user clicks the home button
	//on the nav bar
	verify_session();
}

function verify_session()
{
	//this function will be called whenever home is pressed, the browser 
	//will see if there is a session cookie, if so, the user will be redirected 
	//to the user interface, otherwise they will be asked to login
	
	//get the cookies into an array
	var cookie=document.cookie;
	
	if(cookie=="")
	{
		//this condition occurs if there is no cookie
		window.location.replace("login.html");
			
	}
	else if (cookie.search(';')==-1)
	{
		//check the one cookie to see if it is a session cookie
		cookie=cookie.split('=');
		if(cookie[0]=="session")
		{
			window.location.replace("ui.html");
		}
		else
		{
			window.location.replace("login.html");
		}
	}
	else
	{
		//multiple cookies, check all to see if one is session cookie
		//find the session cookie
		
		var stringer="";
		
		//UNTESTED, NOT SURE IF NECESSARY
		cookie_list=cookie.split(';');
		
		for(var i=0;i<cookie_list.length;i++)
		{
			temp_cookie=cookie_list[i];
			temp_cookie=temp_cookie.split('=');
			//don't forget the space in front of session
			if(temp_cookie[0]==" session")
			{
				//since the cookie is here and not expired, proceed to user interface
				window.location.replace("ui.html");
				return;
			}
			
		}
	window.location.replace("login.html");
	}	
}

function keystroke_handler(next_action)
{
	//this is launched to check if the entered keystroke is "enter"	document.getElementById("error_messages").innerHTML="keystroke!";
	if (window.event && window.event.keyCode ==13)
		next_action();
	else
		return true;
}

function test (stringer)
{
	document.getElementById("message").innerHTML=stringer;
}

function length(obj)
{
	//returns the length of an array that is the result
	//of parsing JSON data.  
	
	//THIS FUNCTION IS BUGGY
	var i=0;
	for (var key in obj)
	{
		if (obj.hasOwnProperty(key)) ++i;
	}
	return i-1;
}
	
function get_date_string(unix_timestamp)
{

	var time=new Date(unix_timestamp*1000);
	var months=['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sept','Oct','Nov','Dec'];
	var year=time.getFullYear();
	var month=months[time.getMonth()];
	var date= time.getDate();
	
	var hour=time.getHours();
	var min=time.getMinutes();
	var sec=time.getSeconds();
	
	var return_value=date+', '+month+' '+year+' '+hour+':'+min+':'+sec;
	return return_value;
	
}

/* Original convert_time function
function convert_time (sec_since_week_start)
{
	//converts the time stored in the database which is seconds since midnight on sunday,
	//to a readable string
	var num=sec_since_week_start/60;
	var num=num-find_day(sec_since_week_start)*1440;
	hour=Math.floor(num/60);
	var min=num-hour*60;
	
	var response="";
	var string_min="";

	if (min<10)
	{
		string_min=string_min.concat("0",min.toString());	
	}
	else
	{
		string_min=min.toString();
	}
	response=response.concat(hour.toString(),":",string_min);
	
	return response;
}
*/

function convert_time (sec_since_week_start)
{
	//converts the time stored in the database which is seconds since midnight on sunday,
	//to a readable string
	
	var d=new Date();
	var utc_factor=d.getTimezoneOffset()*60;
	
	//factor UTC
	if(sec_since_week_start-utc_factor>604800)
	{
		sec_since_week_start=sec_since_week_start-utc_factor-604800;
	}
	else if (sec_since_week_start-utc_factor<0)
	{
		sec_since_week_start=sec_since_week_start-utc_factor+604800;
	}
	else
	{
		sec_since_week_start=sec_since_week_start-utc_factor;
	}


	//The new function converts time and considers the bias for UTC
	var num=sec_since_week_start/60;
	var num=num-find_day(sec_since_week_start)*1440;
	hour=Math.floor(num/60);
	var min=num-hour*60;
	
	var response="";
	var string_min="";

	if (min<10)
	{
		string_min=string_min.concat("0",min.toString());	
	}
	else
	{
		string_min=min.toString();
	}
	response=response.concat(hour.toString(),":",string_min);
	
	return response;
}

function find_day (sec_since_week_start)
{
	//takes the value stored in microcontroller, and converts it into an int
	//representing what day this value is (ex 100000 happens on monday meaning response=1)
	day=Math.floor(sec_since_week_start/(60*60*24));
	return day;
}
	