<?php

	function send_mysql_command($query)
	{
		//this function connects to mySQL submits a query and returns the result
		//it is the calling function's responsibility to parse the results with mysqli_getrow or whatever
		$sql_link=mysqli_connect("localhost","server_handler","raspberry","shade_soleil");	
		if(mysqli_connect_errno())
		{
			exit("ERROR: Could not connect to MySQL");
		}
		$result=mysqli_query($sql_link,$query);
		mysqli_close($sql_link);
		return $result;
	}
	
	function update_svr_check_in($b_id)
	{
		//update the blinds table to record when this schedule was last updated
		$query="UPDATE blinds SET svr_check_in=".time()." WHERE b_id=".$b_id;
		$result=send_mysql_command($query);
	}

	function add_item($b_id,$time,$updown)
	{
		//add a single item into a table specified by inputs
		//ignore if it is a duplicate
		$query="INSERT INTO b_".$b_id." VALUES (".$time.",".$updown.") ON DUPLICATE KEY UPDATE time=time";
		$result=send_mysql_command($query);
		update_svr_check_in($b_id);
	}
	
	function add_many_items($b_id,$time,$updown)
	{
		//apply a scheduled change to all days
		//example, if time=0, the event will happen at midnight of every day
		//ignore if it is a duplicate
		for($i=0;$i<7;$i++)
		{
			$new_time=$time+$i*86400;
			$query="INSERT INTO b_".$b_id." VALUES (".$new_time.",".$updown.") ON DUPLICATE KEY UPDATE time=time";
			$result=send_mysql_command($query);
		}
		update_svr_check_in($b_id);
	}

	function delete_item($b_id,$time)
	{
		//The scheduler should only ever have a single scheduled item.  Remove all
		//records with the given date from the specified table
		$query="DELETE FROM b_".$b_id." WHERE time=".$time;
		$result=send_mysql_command($query);
		update_svr_check_in($b_id);
	}
	
	function logout()
	{
		//read the user's cookie and remove that entry from the session database
		//open sql and clean out all users whose sessions have timed out
		$query="DELETE FROM session WHERE s_id=".$_COOKIE["session"];
		$result=send_mysql_command($query);
	}
	
	function clean_session_db()
	{
		//open sql and clean out all users whose sessions have timed out
		$current_time=time();
		$query="DELETE FROM session WHERE timeout<".$current_time;
		$result=send_mysql_command($query);
	}
	
	function verify_pwd ($u_name, $pwd)
	{
		//returns the p_id and u_name if it is valid. Otherwise, return a string with the array
		$query="SELECT * FROM users WHERE u_name='".$u_name."'";
		$result=send_mysql_command($query);

		
		//Every username must be unique. When we process this result, we will either get 
		//single entry or nothing at all. 
		if($entry=mysqli_fetch_array($result))
		{
			if($entry["pwd"]==$pwd)
			{
				
				$return_value=array($entry["p_id"],$entry["u_name"]);
				return $return_value;
			}
			else
			{
				$return_value=array(-1,"invalid password");
				return $return_value;
			}
		}
		else
		{
			$return_value=array(-1,"invalid username");
			return $return_value;
		}
	}
	
	function verify_cookie ()
	{
		//check that a cookie has been issued, determine who owns that cookie
		//and return all the details of the cookies owner (u_name, p_id etc.)
		//if no cookie, send a timeout error
		
		//ensure the database is up to date
		clean_session_db();
		
		if($_COOKIE["session"]=="")
		{
			exit ("ERROR:Expired Session");
		}
		else
		{
			//check that this session id is in our database
			$query="SELECT * FROM session WHERE (s_id='".$_COOKIE["session"]."')";
			$result=send_mysql_command($query);

			if (mysqli_num_rows($result))
			{	
				//a record exists, return the username and p_id for further use
				$entry=mysqli_fetch_array($result);
				$return_value=array($entry["p_id"],$entry["u_name"]);
				return $return_value;
			}
			else
			{
				//they have a cookie with an invalid session id
				exit ("ERROR:Expired Session");
			}
		}
	}
	
	function retrieve_schedule($b_id)
	{	
		//retrive the session for the given b_id
		$query="SELECT * FROM b_".$b_id." ORDER BY time";
		$result=send_mysql_command($query);

		//create an array to fill with the results
		$return_value=array_fill (0, mysqli_num_rows($result),0);
		for ($i=0;$i<mysqli_num_rows($result);$i++)
		{
			$entry=mysqli_fetch_array($result);
			$return_value[$i]=$entry;
		}

		//encode with JSON and return
		$json_encoded_results=json_encode($return_value);
		return $json_encoded_results;
	}
	
	function update_cookie($p_id,$u_name)
	{
		$query="DELETE FROM session WHERE u_name='".$u_name."'";
		$result=send_mysql_command($query);
	
		$flag=1;
		while($flag)
		{
			//set the flag to 0, if the first random number is not found, issue a new random number
			$flag=0;
			$rando=rand();
			$query="SELECT * FROM session WHERE s_id=".$rando;
			$result=send_mysql_command($query);
			if (!mysqli_num_rows($result))
			{	
				//DON'T REMOVE THE FOLLOWING PHP TENDS TO ENTER AN INFINITE LOOP
				//LOOKING FOR A NUMBER
				while($entry=mysqli_fetch_array($result))
				{
					if($entry["s_id"]==$rando)
					{
						$flag=1;//if this session number is in use, give a new one
					}
				}
			}
		}
		
		//update the record in session table
		$expiry=time()+1800;
		$query="INSERT INTO session (p_id, u_name, s_id, timeout) VALUES (".$p_id.", '".$u_name."', ".$rando.", ".$expiry.")\n";
		$result=send_mysql_command($query);
		
		//issue a cookie to identify this session		
		setcookie("session",$rando,$expiry);	
	}
	
	function dump_data($p_id)
	{
		//prepare a query to find all blinds of owner
		$query="SELECT * FROM blinds WHERE p_id=".$p_id;
		$result=send_mysql_command($query);
		$blinds_array=array_fill(0,3*mysqli_num_rows($result)+1,0);

		//now fill the array with useful information
		//I know its sloppy that this function's index 0 has a count while
		//the schedule document doesn't.  Since this code works, it won't be changed
		$blinds_array[0]=mysqli_num_rows($result);
		
		for ($i=0;$i<$blinds_array[0];$i++)
		{
			//each entry gets three items
			$entry=mysqli_fetch_array($result);
			$blinds_array[$i*3+1]=$entry["b_id"];
			$blinds_array[$i*3+2]=$entry["last_check_in"];
			$blinds_array[$i*3+3]= $entry["state"];
		}
		
		//JSON encode the rest, return the variable as all echo's happen in main loop
		$json_encoded_results=json_encode($blinds_array);
		return $json_encoded_results;
	}
	
	function change_pwd($p_id,$new_pwd){
		//prepare a query to find all blinds of owner
		$query="UPDATE users SET pwd='".$new_pwd."' WHERE p_id=".$p_id."\n";
		$result=send_mysql_command($query);
	}

	switch($_POST["req"])
		{
		case "verify_pwd":
		
			//check password and issue cookie if it is valie. Otherwise, respond with the error
			$result=verify_pwd($_POST["username"],$_POST["password"]);
			if($result[0]!=-1)
			{
				update_cookie($result[0],$result[1]);
				//send command to be redirected to next page
				echo OK;
			}
			else
			{
				//send a message if invalid
				echo $result[1];
			}
			break;
			
		case "status_dump":
			//verify cookie then dump data on owned blinds units
			$result=verify_cookie();
			echo dump_data($result[0]);
			break;
		
		case "logout":
			//run the logout algorithm (remove them from the session table and revoke their cookie)
			logout();
			echo OK;
			break;
			
		case "update_password":
			//check that we've started a valid session
			$result=verify_cookie();
			$p_id=$result[0];
			
			//check password
			$result=verify_pwd($result[1],$_POST["old_pwd"]);
			if($result[0]!=-1)
			{
				change_pwd($p_id,$_POST["new_pwd"]);
				echo "OK";
			}
			else
			{
				echo "The old password entered is incorrect";
			}
			
			break;
			
		case "schedule":
			$result=verify_cookie();
			$response=retrieve_schedule($_POST["b_id"]);
			echo $response;
			break;
			
		case "delete_item":
			$result=verify_cookie();
			delete_item($_POST["b_id"],$_POST["time"]);
			echo OK;
			break;
			
		case "add_item":
			$result=verify_cookie();
			add_item($_POST["b_id"],$_POST["time"],$_POST["updown"]);
			echo OK;
			break;
		
		case "add_many_items":
			$result=verify_cookie();
			add_many_items($_POST["b_id"],$_POST["time"],$_POST["updown"]);
			echo OK;
			break;
		}
		
			
?>